const createError = require('http-errors');
const express = require('express');
const path = require('path');
const cookieParser = require('cookie-parser');
const favicon = require('express-favicon');
const app = express();
const fs = require("fs");
const log = require("loguix")

const { __glob } = require('./bin/global-variables');
const users = require("./bin/users")
const {User} = require("./bin/users")



var wlog = log.getInstance("Serveur")



setup()


function getRouters() {

  wlog.log("Récupération de " + fs.readdirSync(__glob.ROUTES).length + " routeurs depuis : " + __glob.ROUTES)
   for(var route of fs.readdirSync(__glob.ROUTES)) {

      if(route == "index.js") {
     
        app.use("/", require(__glob.ROUTES + "index"))
      } else {
      
        app.use("/" + route.replace(".js", ""), require(__glob.ROUTES + route))
      }

   }
   
}

function setup() {

  app.set('views', path.join(__dirname, 'views'));
  app.set('view engine', 'ejs');



  app.use(express.json());
  app.use(express.urlencoded({ extended: false }));
  app.use(cookieParser());
  app.use(express.static(path.join(__dirname, 'public')));
  app.use(favicon(__glob.ICON));

  getRouters()
  users.fetchUsers()

  // catch 404 and forward to error handler
  app.use(function(req, res, next) {
    res.locals.message = "Page non trouvé";
    res.locals.error = {
      "status": "404",
      "stack": ""
    }

    // render the error page
    res.status(404 || 404);
    res.render('utils/error');
  });

  // error handler
  app.use(function(err, req, res, next) {
    // set locals, only providing error in development
    res.locals.message = err.message;
    res.locals.error = req.app.get('env') === 'development' ? err : {};

    // render the error page
    res.status(err.status || 500);
    res.render('utils/error');
  });



}



module.exports = app;
